#ifndef COLLIDE_H
#define COLLIDE_H

	#define COLLIDE_ALL
	//#define COLLIDE_TWOAABB
	//#define COLLIDE_SEGMENTCIRCLE
	//#define COLLIDE_LINECIRCLE
	//#define COLLIDE_CIRCLEAABB
	//#define COLLIDE_POINTCIRCLE
	//#define COLLIDE_POINTAABB
	//#define COLLIDE_TWOCIRCLE
	//#define COLLIDE_POINTTWOCIRCLE

	#ifdef COLLIDE_ALL
		#define COLLIDE_TWOAABB
		#define COLLIDE_SEGMENTCIRCLE
		#define COLLIDE_LINECIRCLE
		#define COLLIDE_CIRCLEAABB
		#define COLLIDE_POINTCIRCLE
		#define COLLIDE_POINTAABB
		#define COLLIDE_TWOCIRCLE
		#define COLLIDE_POINTTWOCIRCLE
	#endif

	#ifdef COLLIDE_SEGMENTCIRCLE
		#define COLLIDE_LINECIRCLE
		#define COLLIDE_POINTCIRCLE
		#define COLLIDE_POINTAABB
	#endif


	#define SQUARE(x) x * x
	#define SGN(x) (((x)==0)?(0):(((x)<0)?(-1):(1)))
	#define ABS(x) ((((x)<0)?(-(x)):(x)))

	#ifdef _cplusplus
	extern "C" {
	#endif

	typedef enum {
		TRUE, FALSE
	} C_Bool;

	typedef struct {
		int x, y;
	} C_Point;

	typedef struct {
		float x, y;
	} C_FPoint;

	typedef struct {
		float x, y;
	} C_Vector;

	typedef struct {
		int w, h;
	} C_Scale;

	typedef struct {
		int x, y;
		unsigned int w, h;
	} C_AABB;

	typedef struct {
		int x, y;
		float radius;
	} C_Circle;

	typedef struct {
		int x1, y1, x2, y2;
	} C_Segment;

	typedef struct {
		int x1, y1, x2, y2;
	} C_Line;

	typedef struct C_Polygon C_Polygon;
	struct C_Polygon{
		int x, y;
		C_Polygon* next;
	};

	typedef struct {
		C_Polygon *first;
	} C_ListPolygon;

	C_Bool C_TwoAABB(const C_AABB *b1, const C_AABB *b2);
	C_Bool C_PointAABB(const C_Point *p, const C_AABB *b);
	C_Bool C_LineCircle(const C_Line *s, const C_Circle *c);
	C_Bool C_SegmentCircle(const C_Segment *s, const C_Circle *c);
	C_Bool C_PointCircle(const C_Point *s, const C_Circle *c);
	C_Bool C_CircleAABB(const C_Circle *c, const C_AABB *b);
	C_Bool C_TwoCircle(const C_Circle *c1, const C_Circle *c2);
	C_Bool C_PointTwoCircle(C_Point *p, const C_Circle *c1, const C_Circle *c2);

	#ifdef _cplusplus
	}
	#endif

#endif