#ifndef _SYSCALL
#define _SYSCALL

//Dmarre l'application numro 'appno' (commence  0)
//P1, P2 et P4 doivent toujours etre  0;
//Ne fonctionne pas sur l'mulateur
int StartAnyApp(int P1, int P2, int appno, int P4);

//Ajoute une touche dans le buffer de touches
//Exemple, si vous ajoutez KEY_CTRL_EXE, le prochain GetKey(int*) se comportera comme si
//l'utilisateur avait appuy sur EXE
//Je ne sais pas a quoi sert 'mode, a marche avec 0
void KBD_PutKey(unsigned int keycode, int mode);

//Scan les addin de la mmoire de stockage
//Exemple, si votre addin copie un .G1A dans la mmoire de stockage (depuis la carte SD par exemple)
//il faut appeler Register_addin() avant de pouvoir lancer ce .G1A avec StartAnyApp()
void Register_Addin();

//Retourne l'adresse de la VRAM, quelque soit l'OS (fonctionne aussi sur l'mulateur)
char* VRam_Base();


/***********************************************************************/
/** Les 3 syscalls suivants servent a acceder  la mmoire principale **/
/** Je n'ai pas beaucoup d'informations,                              **/
/** je ne vous conseil pas de les utiliser avant d'en savoir plus.    **/
/***********************************************************************/

//Cherche un lment dans un dossier de la mmoire principale.
//Exemple: "system" pour les programmes BASIC, "@REV2" pour les pictures
int MCS_SearchDirectoryItem(unsigned char* dir, unsigned char* item, char* flags_0, void* item_ptr, int* data_ptr, int* data_length);

//Cre un fichier dans un dossier de la mmoire principale et crit dedans.
//dirtype=1 pour le dossier "system", c'est le vrai nom du dossier des programmes BASIC
int MCS_PutInternalItem(char dirtype, unsigned char* item, int data_len, void* buffer);

//Supprime un lment d'un dossier de la mmoire principale
int MCS_DeleteInternalItem(char dirtype, unsigned char* item);


/******************************************************************/
/** TOUS les syscalls suivants sont tirs de fxreverse-doc-1.pdf **/
/******************************************************************/

//Dfini la position du curseur, quivalent  locate(int, int) de fxlib.h
//Retourne 1 si a a march, 0 si les coordonnes sont en dehors de l'cran
int Cursor_SetPosition(char column, char row);

//Dfini le style du curser (0=normal, 1=SHIFT, 2=ALPHA)
//Retourne 1 si a a march, 0 si l'argument n'est pas bon
int Cursor_SetFlashStyle(short int flashstyle);

//Dfini le mode de clignottement du curseur. Si flashmode!=0, le curseur clignotte, si flashmode==0, le curseur ne clignotte plus
void Cursor_SetFlashMode(long flashmode);

//Permet de rcuprer des infos sur le style du curseur
//settingsarray contient dans cet order : colonne, ligne, flash style, fhash mode (il faut donc un tableau de 4 int)
//Retourne : on n'en sait rien
unsigned int Cursor_GetSettings(unsigned int settingsarray[]);

//Equivalent de Cursor_SetFlashMode(0);
void Cursor_SetFlashOff();


/*************************************************************************/
/** Les syscalls suivants servent a appeler les applications du systme **/
/*************************************************************************/

//Les arguments sont les mmes que pour AddIn_main, si runMode vaut 0, c'est qu'on appelle l'application depuis une e-activity
//Dans ce cas, stripNum donne le numro du strip de l'e-activity
//Pour excuter normalement une application, mettez runMode  1
void App_CONICS(int runMode, unsigned short stripNum);
void App_DYNA(int runMode, unsigned short stripNum);
void App_EACT(int runMode, unsigned short stripNum);
void App_EQUA(int runMode, unsigned short stripNum);
void App_PRGM(int runMode, unsigned short stripNum);
void App_FINANCE(int runMode, unsigned short stripNum);
void App_GRAPH(int runMode, unsigned short stripNum);
void App_LINK(int runMode, unsigned short stripNum);
void App_MEMORY(int runMode, unsigned short stripNum);
void App_RECUR(int runMode, unsigned short stripNum);
void App_RUNMAT(int runMode, unsigned short stripNum);
void App_STAT(int runMode, unsigned short stripNum);
void App_SYSTEM(int runMode, unsigned short stripNum);


/**********************************************************/
/** Les syscall suivants servent  l'acces au port srie **/
/** Le buffer de rception fait 1ko,                     **/
/** et le buffer d'envoi fait 256 octets.                **/
/**********************************************************/

//Lit un caractre du buffer de rception et le copie a l'adresse pointe par 'dest'
//Retourne 0 en cas de succes, 1 si le buffer est vide, 3 si la connexion n'est pas tablie
int Serial_ReadByte(unsigned char *dest);

//Lit 'max' octets du buffer de rception et les crit dans 'dest'
//'size' donne le nombre d'octets lu
//Retourne 0 en cas de succes, 1 si le buffer est vide, 3 si la connexion n'est pas tablie
int Serial_ReadBytes(unsigned char *dest, int max, short *size);

//Ecrit 'byte' dans le buffer d'envoi
//Retourne 0
int Serial_WriteByte(unsigned char byte);

//Ecrit 'size' octets dans le buffer d'envoi depuis l'adresse 'scr'
//Retourne 0 en cas de succes, 2 si le buffer est trop plein, 3 si la connexion n'est pas tablie
int Serial_WriteBytes(unsigned char *src, int size);

//FIFO = first in first out
int Serial_WriteByteFIFO(unsigned char byte);

//Retourne la taille des donnes du buffer de rception
int Serial_GetRxBufferSize(void);

//Retourne l'espace disponible dans le buffer d'envoi
int Serial_GetTxBufferFreeCapacity(void);

//Vide le buffer de rception
//Retourne 0 en cas de succes, 3 si la connexion n'est pas tablie
int Serial_ClearReceiveBuffer(void);

//Vide le buffer d'envoi
//Retourne 0
int Serial_ClearTransmitBuffer(void);

//Ouvre et prpare l'interface de communication
//Pour plus de dtails, consulter fxreverse-doc-1.pdf ci joint
int Serial_Open(unsigned char *conf);

//Ferme l'interface de communication et vide les buffers d'envoi et de rception
//Si 'mode'==1, la communication est coupe sans regarder s'il reste des donnes a transmettre
//Si 'mode'!=1, la fonction ne ferme pas l'interface de communication s'il reste des donnes a transmettre
//et retourne 5
//Retourne 0 en cas de succes (communication termine) et 5 s'il reste des donnes a transmettre
int Serial_Close(int mode);

//Copie l'octet numro 'index' du buffer de rception vers 'dest' si 'index' ne dpasse pas les donnes du buffer
//Retourne 0 en cas de succes, 1 si 'index' dpasse les donnes du buffer, 3 si la communication n'est pas tablie
int Serial_Peek(int index, unsigned char *dest);

//Rcupre le statut de la connexion
//Retourne 1 si la connexion est tablie, 3 sinon
int Serial_IsOpen(void);

/*********************************************************************/
/** Les syscalls suivants servent a l'acces aux variables Setup     **/
/** Il est prcis dans la doc que ces syscall sont valides         **/
/** pour l'OS 1.2, mais peut etre pas pour les versions suprieures **/
/*********************************************************************/

//Lit la variable Setup numro 'index'
//Retourne la valeur de la variables Setup numro 'index'
char Setup_GetEntry(unsigned int index);

//Ecrit la valeur 'value' dans la variables Setup numro 'index'
//Retourne l'adresse du tableau des variables Setup
char *Setup_SetEntry(unsigned int index, char value);

//Retourne l'adresse de la variable Setup numro 'index'
char *Setup_GetEntryPtr(unsigned int index);

/*************************************************************************/
/** Les syscalls suivants servent a acceder aux variables               **/
/** utilises par les programmes BASIC, A-Z, r, theta et Ans.           **/
/** Les variables A-Z sont reprsentes par leur code ASCII (0x41-0x5A) **/
/** r, thete et Ans sont reprsentes par les codes 0xCE, 0xCD et 0xC0  **/
/*************************************************************************/

//Lit la variable 'variable' et copie sa valeur dans 'dest'
//'dest' doit etre un tableau de 24 octets
//Retourne le pointeur envoy, 'dest'
char *Alpha_GetData(char variable, char *dest);

//Ecrit le contenu de 'scr' dans la variable 'variable'
//'scr doit etre un tableau de 24 octets
//Si 'variable' est valide, retourne 0, sinon retourne 'variable'
char Alpha_SetData(char variable, char *src);

//Initialise toutes les variables Alpha, except Ans
void Alpha_ClearAll(void);

#endif
